/////////////////////////////////////////////////////////////////////
//                               41 Post                           //
// Game Programming Basics: Moving an element                      //
// Created by DimasTheDriver on 28/Dez/2010                        //
// Availiable at:       http://www.41post.com/?p=2039              //
/////////////////////////////////////////////////////////////////////

//a variable that we will load the image into
PImage circle;
//a variable to load a font for all the text
PFont calibri;
//a string to output messages
String inertiaMessage="Inertia is DISABLED. Press 'i' to enable it."; 


//initial ball position
float posX = 234;
float posY = 109;

//initial velocities
float velX = 4;
float velY = 4;

//a boleean to check if ineria is enabled
boolean inertia = false;

//a boolean to check if the button was clicked
boolean overButton = false;

void setup()
{
  //window size
  size(500,250);
  
  //loads the image
  circle = loadImage("objimage.png");
  
  //loads the font
  calibri = loadFont("Calibri-12.vlw");
  
  //sets the font for all texts
  textFont(calibri);
  
  //lock/limit the frame rate
  frameRate(60);
}

void Update()
{
  //limit the ball position
  if(posX >= 499)
  {
    posX = -32;
  }
  else if(posX <= -32)
  {
    posX = 499;
  }
  if(posY <= -31)
  {
    posY = 250;
  }
  else if(posY >= 250)
  {
    posY = -31;
  }
  
  //if inertia is enabled:
  if(inertia)
  {
    //remove 5% from the total velocity
    velX = velX *0.95;
    velY = velY *0.95;
    //add this velocity to the position
    posX = posX + velX;
    posY = posY + velY;
  }
  
  //Check if 'back to post' button was pressed
  checkButton();
}

void draw()
{
  //call the update method defined above
  Update();
  
  //refresh the background
   background(243,235,224);
   
  //Displays the blue ball
  image(circle, posX, posY);
  
  //Displays instructions and messages
  
  //set text color
  fill(128,97,77);
  
  //instructions
  text("Hold down any of the arrow keys to move the blue object in the desired direction.",10,15);
  
  //inertia message
  text(inertiaMessage, 10, 245);
  
  //the current postion
  text("posX :" + posX, 405, 200);
  text("posY :" + posY, 405, 215);
  
  //the current velocity
  text("velX :" + velX, 405, 230);
  text("velY :" + velY, 405, 245);
  
  
  //back to post button
  fill(17,82,128);
  text("Click here to return to post.", 243, 245);
}

void keyPressed()
{
  //keys that make the object move
  if(key == CODED)
  {
    //if inertia is disabled
    if(!inertia)
    {
      //Right
      if (keyCode == RIGHT) 
      {
        posX = posX + velX; 
      }
      //Left
      if (keyCode == LEFT) 
      {
        posX = posX - velX; 
      }
      //Down
      if (keyCode == DOWN) 
      {
        posY = posY + velY; 
      }
      //Up
      if (keyCode == UP) 
      {
        posY = posY - velY;
      }
    }
    else //inertia is enabled
    {
      //Right
      if (keyCode == RIGHT) 
      {
        velX++;
      }
      //Left
      if (keyCode == LEFT) 
      {
        velX--;
      }
      //Down
      if (keyCode == DOWN) 
      {
        velY++; 
      }
      //Up
      if (keyCode == UP) 
      {
        velY--;
      }
    }
  }
  else
  {
    //reset to initial position.
    if(key == 'r')
    {
      //initial position
      posX = 234;
      posY = 109;
    }
    
    //enable/disable inertia
    if(key == 'i')
    {
      if(!inertia)//enable inertia
      {
        //sets the inertia to true
        inertia = true;
      
        //sets velX and velY to 0
        velX=0;
        velY=0;
        
        //Tells the user that inertia is enabled
        inertiaMessage = "Inertia is ENABLED.";
        
        //return to skip the next if statement block
        return;
      }
      if(inertia)//disable inertia
      {
        //set the boolean to false
        inertia = false;
        
        //set velX and VelY to its original values
        velX = 4;
        velY = 4;
        
        //set inertia string to tell the user inertia was disabled
        inertiaMessage = "Inertia is DISABLED. Press 'i' to enable it.";
      }
    }
  }
}

void mousePressed()
{
  if(overButton)
  {
     //go back to post
     link("http://www.41post.com/?p=2039","_new");
  }
}

//checks if we clicked on the 'Back to post button'
void checkButton() 
{
  if (mouseX > 243 && mouseX < 395 && mouseY > 237 && mouseY < 247) 
  {
    overButton = true;   
  } 
  else 
  {
    overButton = false;
  }
}


